]> git.ipfire.org Git - thirdparty/dracut.git/blame - dracut.sh
Merge pull request #276 from danimo/copy_multipath_confd
[thirdparty/dracut.git] / dracut.sh
CommitLineData
6ac2c835 1#!/bin/bash --norc
3b403b32 2#
641cc356
JK
3# Generator script for a dracut initramfs
4# Tries to retain some degree of compatibility with the command line
5# of the various mkinitrd implementations out there
6#
70c26b7f 7
7d848c55 8# Copyright 2005-2013 Red Hat, Inc. All rights reserved.
4f18fe82
HH
9#
10# This program is free software; you can redistribute it and/or modify
11# it under the terms of the GNU General Public License as published by
12# the Free Software Foundation; either version 2 of the License, or
13# (at your option) any later version.
14#
15# This program is distributed in the hope that it will be useful,
16# but WITHOUT ANY WARRANTY; without even the implied warranty of
17# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
18# GNU General Public License for more details.
19#
20# You should have received a copy of the GNU General Public License
21# along with this program. If not, see <http://www.gnu.org/licenses/>.
22#
ec9315e5 23
58dad702 24# store for logging
ee44f629
HH
25
26# Verify bash version, current minimum is 4
27if (( BASH_VERSINFO[0] < 4 )); then
28 printf -- 'You need at least Bash 4 to use dracut, sorry.' >&2
29 exit 1
30fi
31
ffa71b4a 32dracut_args=( "$@" )
e8f19bcf 33readonly dracut_cmd="$(readlink -f $0)"
5616feb0 34
7abd4264
HH
35set -o pipefail
36
5616feb0 37usage() {
dbf8f6ba
HH
38 [[ $dracutbasedir ]] || dracutbasedir=/usr/lib/dracut
39 if [[ -f $dracutbasedir/dracut-version.sh ]]; then
40 . $dracutbasedir/dracut-version.sh
41 fi
42
5616feb0 43# 80x25 linebreak here ^
cc02093d 44 cat << EOF
e8f19bcf 45Usage: $dracut_cmd [OPTION]... [<initramfs> [<kernel-version>]]
ffa71b4a
HH
46
47Version: $DRACUT_VERSION
48
49Creates initial ramdisk images for preloading modules
50
51 -h, --help Display all options
52
53If a [LIST] has multiple arguments, then you have to put these in quotes.
54
55For example:
56
57 # dracut --add-drivers "module1 module2" ...
58
59EOF
60}
61
62long_usage() {
63 [[ $dracutbasedir ]] || dracutbasedir=/usr/lib/dracut
64 if [[ -f $dracutbasedir/dracut-version.sh ]]; then
65 . $dracutbasedir/dracut-version.sh
66 fi
67
68# 80x25 linebreak here ^
69 cat << EOF
e8f19bcf 70Usage: $dracut_cmd [OPTION]... [<initramfs> [<kernel-version>]]
dbf8f6ba
HH
71
72Version: $DRACUT_VERSION
73
5616feb0
AT
74Creates initial ramdisk images for preloading modules
75
e65caf36 76 --kver [VERSION] Set kernel version to [VERSION].
39ff0682 77 -f, --force Overwrite existing initramfs file.
54e7d7c3 78 -a, --add [LIST] Add a space-separated list of dracut modules.
659dc319 79 --rebuild Append arguments to those of existing image and rebuild
5616feb0
AT
80 -m, --modules [LIST] Specify a space-separated list of dracut modules to
81 call when building the initramfs. Modules are located
c5a65990 82 in /usr/lib/dracut/modules.d.
39ff0682 83 -o, --omit [LIST] Omit a space-separated list of dracut modules.
ea3c4e82
HH
84 --force-add [LIST] Force to add a space-separated list of dracut modules
85 to the default set of modules, when -H is specified.
5616feb0 86 -d, --drivers [LIST] Specify a space-separated list of kernel modules to
ea3c4e82
HH
87 exclusively include in the initramfs.
88 --add-drivers [LIST] Specify a space-separated list of kernel
89 modules to add to the initramfs.
cea907f6
TR
90 --force-drivers [LIST] Specify a space-separated list of kernel
91 modules to add to the initramfs and make sure they
92 are tried to be loaded via modprobe same as passing
93 rd.driver.pre=DRIVER kernel parameter.
fcbcb252 94 --omit-drivers [LIST] Specify a space-separated list of kernel
ea3c4e82 95 modules not to add to the initramfs.
8fa510d4 96 --filesystems [LIST] Specify a space-separated list of kernel filesystem
ea3c4e82
HH
97 modules to exclusively include in the generic
98 initramfs.
3b403b32 99 -k, --kmoddir [DIR] Specify the directory, where to look for kernel
ea3c4e82 100 modules
3b403b32 101 --fwdir [DIR] Specify additional directories, where to look for
ea3c4e82 102 firmwares, separated by :
33ee031c
HH
103 --kernel-only Only install kernel drivers and firmware files
104 --no-kernel Do not install kernel drivers and firmware files
1743473b 105 --print-cmdline Print the kernel command line for the given disk layout
5bbfd484 106 --early-microcode Combine early microcode with ramdisk
5f2c30d9 107 --no-early-microcode Do not combine early microcode with ramdisk
d20fb951 108 --kernel-cmdline [PARAMETERS] Specify default kernel command line parameters
54e7d7c3 109 --strip Strip binaries in the initramfs
6c128565 110 --nostrip Do not strip binaries in the initramfs
f4a94278
HH
111 --prelink Prelink binaries in the initramfs
112 --noprelink Do not prelink binaries in the initramfs
54e7d7c3 113 --hardlink Hardlink files in the initramfs
04d18f55 114 --nohardlink Do not hardlink files in the initramfs
fd786adc 115 --prefix [DIR] Prefix initramfs files with [DIR]
54e7d7c3 116 --noprefix Do not prefix initramfs files
2f02ae9d
HH
117 --mdadmconf Include local /etc/mdadm.conf
118 --nomdadmconf Do not include local /etc/mdadm.conf
7a34efa5 119 --lvmconf Include local /etc/lvm/lvm.conf
cc02093d 120 --nolvmconf Do not include local /etc/lvm/lvm.conf
25b45979
MS
121 --fscks [LIST] Add a space-separated list of fsck helpers.
122 --nofscks Inhibit installation of any fsck helpers.
ff3953ef 123 --ro-mnt Mount / and /usr read-only by default.
5616feb0 124 -h, --help This message
00531568 125 --debug Output debug information of the build process
57258a2c 126 --profile Output profile information of the build process
e103615b
127 -L, --stdlog [0-6] Specify logging level (to standard error)
128 0 - suppress any messages
129 1 - only fatal errors
130 2 - all errors
131 3 - warnings
54e7d7c3 132 4 - info
e103615b
133 5 - debug info (here starts lots of output)
134 6 - trace info (and even more)
54e7d7c3
HH
135 -v, --verbose Increase verbosity level
136 -q, --quiet Decrease verbosity level
5616feb0
AT
137 -c, --conf [FILE] Specify configuration file to use.
138 Default: /etc/dracut.conf
3b403b32 139 --confdir [DIR] Specify configuration directory to use *.conf files
cc02093d 140 from. Default: /etc/dracut.conf.d
882c4c5a
141 --tmpdir [DIR] Temporary directory to be used instead of default
142 /var/tmp.
5616feb0
AT
143 -l, --local Local mode. Use modules from the current working
144 directory instead of the system-wide installed in
c5a65990 145 /usr/lib/dracut/modules.d.
5616feb0 146 Useful when running dracut from a git checkout.
7c179686 147 -H, --hostonly Host-Only mode: Install only what is needed for
324ea606 148 booting the local host instead of a generic host.
472189da 149 -N, --no-hostonly Disables Host-Only mode
ab9457ef
HH
150 --hostonly-cmdline Store kernel command line arguments needed
151 in the initramfs
152 --no-hostonly-cmdline Do not store kernel command line arguments needed
153 in the initramfs
37f2fe55
XP
154 --no-hostonly-default-device
155 Do not generate implicit host devices like root,
156 swap, fstab, etc. Use "--mount" or "--add-device"
157 to explicitly add devices as needed.
f367b738
HH
158 --hostonly-i18n Install only needed keyboard and font files according
159 to the host configuration (default).
160 --no-hostonly-i18n Install all keyboard and font files available.
324ea606
HH
161 --persistent-policy [POLICY]
162 Use [POLICY] to address disks and partitions.
163 POLICY can be any directory name found in /dev/disk.
164 E.g. "by-uuid", "by-label"
7c179686 165 --fstab Use /etc/fstab to determine the root device.
70cb8a68
HH
166 --add-fstab [FILE] Add file to the initramfs fstab
167 --mount "[DEV] [MP] [FSTYPE] [FSOPTS]"
168 Mount device [DEV] on mountpoint [MP] with filesystem
169 [FSTYPE] and options [FSOPTS] in the initramfs
edbd9ca0
FV
170 --mount "[MP]" Same as above, but [DEV], [FSTYPE] and [FSOPTS] are
171 determined by looking at the current mounts.
c586b033 172 --add-device "[DEV]" Bring up [DEV] in initramfs
5616feb0 173 -i, --include [SOURCE] [TARGET]
39ff0682
AT
174 Include the files in the SOURCE directory into the
175 Target directory in the final initramfs.
3b403b32 176 If SOURCE is a file, it will be installed to TARGET
4fea3ea6 177 in the final initramfs.
39ff0682
AT
178 -I, --install [LIST] Install the space separated list of files into the
179 initramfs.
54b68829
HH
180 --install-optional [LIST] Install the space separated list of files into the
181 initramfs, if they exist.
5b158ad3 182 --gzip Compress the generated initramfs using gzip.
cc02093d
HH
183 This will be done by default, unless another
184 compression option or --no-compress is passed.
5b158ad3 185 --bzip2 Compress the generated initramfs using bzip2.
cc02093d
HH
186 Make sure your kernel has bzip2 decompression support
187 compiled in, otherwise you will not be able to boot.
188 --lzma Compress the generated initramfs using lzma.
3b403b32 189 Make sure your kernel has lzma support compiled in,
cc02093d 190 otherwise you will not be able to boot.
5e6c3b03
VL
191 --xz Compress the generated initramfs using xz.
192 Make sure that your kernel has xz support compiled
193 in, otherwise you will not be able to boot.
37383f71 194 --lzo Compress the generated initramfs using lzop.
871c8e40 195 Make sure that your kernel has lzo support compiled
196 in, otherwise you will not be able to boot.
37383f71 197 --lz4 Compress the generated initramfs using lz4.
871c8e40 198 Make sure that your kernel has lz4 support compiled
199 in, otherwise you will not be able to boot.
5e6c3b03
VL
200 --compress [COMPRESSION] Compress the generated initramfs with the
201 passed compression program. Make sure your kernel
3b403b32 202 knows how to decompress the generated initramfs,
5e6c3b03 203 otherwise you will not be able to boot.
5b158ad3 204 --no-compress Do not compress the generated initramfs. This will
cc02093d 205 override any other compression options.
5b11bb73 206 --list-modules List all available dracut modules.
956af8f2
207 -M, --show-modules Print included module's name to standard output during
208 build.
5fe5c7d0 209 --keep Keep the temporary initramfs for debugging purposes
ec3c5951 210 --printsize Print out the module install size
cdfeb278 211 --sshkey [SSHKEY] Add ssh key to initramfs (use with ssh-client module)
ee54b840 212 --logfile [FILE] Logfile to use (overrides configuration setting)
80626ded 213 --reproducible Create reproducible images
10f8df1b 214 --no-reproducible Do not create reproducible images
37383f71 215 --loginstall [DIR] Log all files installed from the host to [DIR]
636d2d46
HH
216 --uefi Create an UEFI executable with the kernel cmdline and
217 kernel combined
218 --uefi-stub [FILE] Use the UEFI stub [FILE] to create an UEFI executable
219 --kernel-image [FILE] location of the kernel image
ccaa9bee
HH
220
221If [LIST] has multiple arguments, then you have to put these in quotes.
ffa71b4a 222
ccaa9bee 223For example:
ffa71b4a
HH
224
225 # dracut --add-drivers "module1 module2" ...
226
cc02093d 227EOF
5616feb0
AT
228}
229
118ca9ec
TR
230# Fills up host_devs stack variable and makes sure there are no duplicates
231push_host_devs() {
232 local _dev
694725ab
HH
233 for _dev in "$@"; do
234 [[ " ${host_devs[@]} " == *" $_dev "* ]] && return
235 host_devs+=( "$_dev" )
236 done
8466db96
HH
237}
238
5bc545ed
VL
239# Little helper function for reading args from the commandline.
240# it automatically handles -a b and -a=b variants, and returns 1 if
241# we need to shift $3.
242read_arg() {
243 # $1 = arg name
244 # $2 = arg value
245 # $3 = arg parameter
246 local rematch='^[^=]*=(.*)$'
247 if [[ $2 =~ $rematch ]]; then
cc02093d 248 read "$1" <<< "${BASH_REMATCH[1]}"
5bc545ed 249 else
cc02093d
HH
250 read "$1" <<< "$3"
251 # There is no way to shift our callers args, so
252 # return 1 to indicate they should do it instead.
253 return 1
5bc545ed
VL
254 fi
255}
256
335bc217 257dropindirs_sort()
a42b2b81 258{
b093aa2d
HH
259 local suffix=$1; shift
260 local -a files
261 local f d
262
dba20559
HH
263 for d in "$@"; do
264 for i in "$d/"*"$suffix"; do
265 if [[ -e "$i" ]]; then
266 printf "%s\n" "${i##*/}"
267 fi
268 done
269 done | sort -Vu | {
270 readarray -t files
271
272 for f in "${files[@]}"; do
273 for d in "$@"; do
274 if [[ -e "$d/$f" ]]; then
275 printf "%s\n" "$d/$f"
276 continue 2
b093aa2d 277 fi
a42b2b81 278 done
a42b2b81 279 done
dba20559 280 }
a42b2b81
HH
281}
282
659dc319
HB
283rearrange_params()
284{
285 # Workaround -i, --include taking 2 arguments
286 set -- "${@/--include/++include}"
287
288 # This prevents any long argument ending with "-i"
289 # -i, like --opt-i but I think we can just prevent that
290 set -- "${@/%-i/++include}"
291
292 TEMP=$(unset POSIXLY_CORRECT; getopt \
293 -o "a:m:o:d:I:k:c:L:fvqlHhMN" \
294 --long kver: \
295 --long add: \
296 --long force-add: \
297 --long add-drivers: \
cea907f6 298 --long force-drivers: \
659dc319
HB
299 --long omit-drivers: \
300 --long modules: \
301 --long omit: \
302 --long drivers: \
303 --long filesystems: \
304 --long install: \
54b68829 305 --long install-optional: \
659dc319
HB
306 --long fwdir: \
307 --long libdirs: \
308 --long fscks: \
309 --long add-fstab: \
310 --long mount: \
311 --long device: \
312 --long add-device: \
ae989390 313 --long nofscks \
659dc319
HB
314 --long ro-mnt \
315 --long kmoddir: \
316 --long conf: \
317 --long confdir: \
318 --long tmpdir: \
319 --long stdlog: \
320 --long compress: \
321 --long prefix: \
322 --long rebuild: \
323 --long force \
324 --long kernel-only \
325 --long no-kernel \
326 --long print-cmdline \
327 --long kernel-cmdline: \
328 --long strip \
329 --long nostrip \
330 --long prelink \
331 --long noprelink \
332 --long hardlink \
333 --long nohardlink \
334 --long noprefix \
335 --long mdadmconf \
336 --long nomdadmconf \
337 --long lvmconf \
338 --long nolvmconf \
339 --long debug \
340 --long profile \
341 --long sshkey: \
342 --long logfile: \
343 --long verbose \
344 --long quiet \
345 --long local \
346 --long hostonly \
347 --long host-only \
348 --long no-hostonly \
349 --long no-host-only \
646e0506
WC
350 --long hostonly-cmdline \
351 --long no-hostonly-cmdline \
37f2fe55 352 --long no-hostonly-default-device \
659dc319
HB
353 --long persistent-policy: \
354 --long fstab \
355 --long help \
356 --long bzip2 \
357 --long lzma \
358 --long xz \
359 --long lzo \
360 --long lz4 \
361 --long no-compress \
362 --long gzip \
363 --long list-modules \
364 --long show-modules \
365 --long keep \
366 --long printsize \
367 --long regenerate-all \
368 --long noimageifnotneeded \
369 --long early-microcode \
370 --long no-early-microcode \
80626ded 371 --long reproducible \
10f8df1b 372 --long no-reproducible \
37383f71 373 --long loginstall: \
636d2d46
HH
374 --long uefi \
375 --long uefi-stub: \
376 --long kernel-image: \
b73e00af
HH
377 --long no-hostonly-i18n \
378 --long hostonly-i18n \
5c57209b 379 --long no-machineid \
659dc319
HB
380 -- "$@")
381
382 if (( $? != 0 )); then
383 usage
384 exit 1
385 fi
386}
387
432196ae 388verbosity_mod_l=0
f79e587c
HH
389unset kernel
390unset outfile
486a1b93 391
659dc319
HB
392rearrange_params "$@"
393eval set -- "$TEMP"
394
395# parse command line args to check if '--rebuild' option is present
396unset append_args_l
397unset rebuild_file
398while :
399do
400 if [ "$1" == "--" ]; then
401 shift; break
402 fi
403 if [ "$1" == "--rebuild" ]; then
404 append_args_l="yes"
405 rebuild_file=$2
406 if [ ! -e $rebuild_file ]; then
407 echo "Image file '$rebuild_file', for rebuild, does not exist!"
408 exit 1
409 fi
410 abs_rebuild_file=$(readlink -f "$rebuild_file") && rebuild_file="$abs_rebuild_file"
411 shift; continue
412 fi
413 shift
414done
415
416# get output file name and kernel version from command line arguments
417while (($# > 0)); do
418 case ${1%%=*} in
419 ++include)
420 shift 2;;
421 *)
422 if ! [[ ${outfile+x} ]]; then
423 outfile=$1
424 elif ! [[ ${kernel+x} ]]; then
425 kernel=$1
426 else
427 printf "\nUnknown arguments: %s\n\n" "$*" >&2
428 usage; exit 1;
429 fi
430 ;;
431 esac
432 shift
433done
434
435# extract input image file provided with rebuild option to get previous parameters, if any
436if [[ $append_args_l == "yes" ]]; then
437 unset rebuild_param
438
439 # determine resultant file
440 if ! [[ $outfile ]]; then
441 outfile=$rebuild_file
442 fi
443
444 if ! rebuild_param=$(lsinitrd $rebuild_file '*lib/dracut/build-parameter.txt'); then
445 echo "Image '$rebuild_file' has no rebuild information stored"
446 exit 1
447 fi
448
449 # prepend previous parameters to current command line args
450 if [[ $rebuild_param ]]; then
451 TEMP="$rebuild_param $TEMP"
452 eval set -- "$TEMP"
453 rearrange_params "$@"
454 fi
455
456 # clean the temporarily used scratch-pad directory
457 rm -rf $scratch_dir
ffa71b4a
HH
458fi
459
659dc319
HB
460unset PARMS_TO_STORE
461PARMS_TO_STORE=""
462
ffa71b4a
HH
463eval set -- "$TEMP"
464
465while :; do
659dc319
HB
466 if [ $1 != "--" ] && [ $1 != "--rebuild" ]; then
467 PARMS_TO_STORE+=" $1";
468 fi
ffa71b4a 469 case $1 in
5a66d511
HH
470 --kver) kernel="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
471 -a|--add) add_dracutmodules_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
472 --force-add) force_add_dracutmodules_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
473 --add-drivers) add_drivers_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
474 --force-drivers) force_drivers_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
475 --omit-drivers) omit_drivers_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
476 -m|--modules) dracutmodules_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
477 -o|--omit) omit_dracutmodules_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
478 -d|--drivers) drivers_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
479 --filesystems) filesystems_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
480 -I|--install) install_items_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
481 --install-optional) install_optional_items_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
482 --fwdir) fw_dir_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
483 --libdirs) libdirs_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
484 --fscks) fscks_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
485 --add-fstab) add_fstab_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
486 --mount) fstab_lines+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
487 --add-device|--device) add_device_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
488 --kernel-cmdline) kernel_cmdline_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
25b45979 489 --nofscks) nofscks_l="yes";;
ff3953ef 490 --ro-mnt) ro_mnt_l="yes";;
659dc319
HB
491 -k|--kmoddir) drivers_dir_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
492 -c|--conf) conffile="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
493 --confdir) confdir="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
494 --tmpdir) tmpdir_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
495 -L|--stdlog) stdloglvl_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
496 --compress) compress_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
497 --prefix) prefix_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
37383f71 498 --loginstall) loginstall_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
659dc319
HB
499 --rebuild) if [ $rebuild_file == $outfile ]; then
500 force=yes
501 fi
502 shift
503 ;;
cc02093d
HH
504 -f|--force) force=yes;;
505 --kernel-only) kernel_only="yes"; no_kernel="no";;
506 --no-kernel) kernel_only="no"; no_kernel="yes";;
ab9457ef
HH
507 --print-cmdline)
508 print_cmdline="yes"; hostonly_l="yes"; kernel_only="yes"; no_kernel="yes";;
509 --early-microcode)
510 early_microcode_l="yes";;
511 --no-early-microcode)
512 early_microcode_l="no";;
cc02093d
HH
513 --strip) do_strip_l="yes";;
514 --nostrip) do_strip_l="no";;
f4a94278
HH
515 --prelink) do_prelink_l="yes";;
516 --noprelink) do_prelink_l="no";;
04d18f55
HH
517 --hardlink) do_hardlink_l="yes";;
518 --nohardlink) do_hardlink_l="no";;
fd786adc 519 --noprefix) prefix_l="/";;
690396a5
VL
520 --mdadmconf) mdadmconf_l="yes";;
521 --nomdadmconf) mdadmconf_l="no";;
522 --lvmconf) lvmconf_l="yes";;
523 --nolvmconf) lvmconf_l="no";;
cc02093d 524 --debug) debug="yes";;
57258a2c 525 --profile) profile="yes";;
659dc319 526 --sshkey) sshkey="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
ee54b840 527 --logfile) logfile_l="$2"; shift;;
432196ae
528 -v|--verbose) ((verbosity_mod_l++));;
529 -q|--quiet) ((verbosity_mod_l--));;
dbf8f6ba
HH
530 -l|--local)
531 allowlocal="yes"
777f2db0 532 [[ -f "$(readlink -f "${0%/*}")/dracut-init.sh" ]] \
b093aa2d 533 && dracutbasedir="$(readlink -f "${0%/*}")"
dbf8f6ba 534 ;;
ea3c4e82
HH
535 -H|--hostonly|--host-only)
536 hostonly_l="yes" ;;
537 -N|--no-hostonly|--no-host-only)
538 hostonly_l="no" ;;
ab9457ef
HH
539 --hostonly-cmdline)
540 hostonly_cmdline_l="yes" ;;
b73e00af
HH
541 --hostonly-i18n)
542 i18n_install_all_l="no" ;;
543 --no-hostonly-i18n)
544 i18n_install_all_l="yes" ;;
ab9457ef
HH
545 --no-hostonly-cmdline)
546 hostonly_cmdline_l="no" ;;
37f2fe55
XP
547 --no-hostonly-default-device)
548 hostonly_default_device="no" ;;
324ea606 549 --persistent-policy)
659dc319 550 persistent_policy_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
cc02093d 551 --fstab) use_fstab_l="yes" ;;
ffa71b4a 552 -h|--help) long_usage; exit 1 ;;
5a66d511 553 -i|--include) include_src+=("$2"); PARMS_TO_STORE+=" '$2'";
ffa71b4a 554 shift;;
3a714439
VL
555 --bzip2) compress_l="bzip2";;
556 --lzma) compress_l="lzma";;
557 --xz) compress_l="xz";;
871c8e40 558 --lzo) compress_l="lzo";;
559 --lz4) compress_l="lz4";;
3a714439
VL
560 --no-compress) _no_compress_l="cat";;
561 --gzip) compress_l="gzip";;
ffa71b4a 562 --list-modules) do_list="yes";;
956af8f2
563 -M|--show-modules)
564 show_modules_l="yes"
565 ;;
5fe5c7d0 566 --keep) keep="yes";;
ec3c5951 567 --printsize) printsize="yes";;
7d848c55 568 --regenerate-all) regenerate_all="yes";;
83bb0893 569 --noimageifnotneeded) noimageifnotneeded="yes";;
80626ded 570 --reproducible) reproducible_l="yes";;
10f8df1b 571 --no-reproducible) reproducible_l="no";;
636d2d46
HH
572 --uefi) uefi="yes";;
573 --uefi-stub)
574 uefi_stub_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
575 --kernel-image)
576 kernel_image_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
5c57209b
HH
577 --no-machineid)
578 machine_id_l="no";;
ffa71b4a
HH
579 --) shift; break;;
580
581 *) # should not even reach this point
582 printf "\n!Unknown option: '%s'\n\n" "$1" >&2; usage; exit 1;;
583 esac
584 shift
585done
586
587# getopt cannot handle multiple arguments, so just handle "-I,--include"
588# the old fashioned way
589
590while (($# > 0)); do
4eec1a22 591 if [ "${1%%=*}" == "++include" ]; then
5a66d511
HH
592 include_src+=("$2")
593 include_target+=("$3")
659dc319
HB
594 PARMS_TO_STORE+=" --include '$2' '$3'"
595 shift 2
596 fi
b368a5f3 597 shift
641cc356 598done
ffa71b4a 599
7d848c55
HH
600if [[ $regenerate_all == "yes" ]]; then
601 ret=0
602 if [[ $kernel ]]; then
b093aa2d 603 printf -- "--regenerate-all cannot be called with a kernel version\n" >&2
7d848c55
HH
604 exit 1
605 fi
606
607 if [[ $outfile ]]; then
b093aa2d 608 printf -- "--regenerate-all cannot be called with a image file\n" >&2
7d848c55
HH
609 exit 1
610 fi
611
612 ((len=${#dracut_args[@]}))
613 for ((i=0; i < len; i++)); do
614 [[ ${dracut_args[$i]} == "--regenerate-all" ]] && \
615 unset dracut_args[$i]
616 done
617
618 cd /lib/modules
619 for i in *; do
b29cb516 620 [[ -f $i/modules.dep ]] || [[ -f $i/modules.dep.bin ]] || continue
e8f19bcf 621 "$dracut_cmd" --kver="$i" "${dracut_args[@]}"
7d848c55
HH
622 ((ret+=$?))
623 done
624 exit $ret
625fi
626
8a5354a9 627if ! [[ $kernel ]]; then
486a1b93
HH
628 kernel=$(uname -r)
629fi
ffa71b4a 630
02b5c8e3
HH
631export LC_ALL=C
632export LANG=C
8a32bf61
HH
633unset LC_MESSAGES
634unset LC_CTYPE
d619fb5e 635unset LD_LIBRARY_PATH
45404a2a 636unset LD_PRELOAD
1fcf2d2f 637unset GREP_OPTIONS
a55711cd 638
89d44e72 639export DRACUT_LOG_LEVEL=warning
3b403b32 640[[ $debug ]] && {
89d44e72 641 export DRACUT_LOG_LEVEL=debug
c36ce334
VL
642 export PS4='${BASH_SOURCE}@${LINENO}(${FUNCNAME[0]}): ';
643 set -x
644}
645
57258a2c
HH
646[[ $profile ]] && {
647 export PS4='+ $(date "+%s.%N") ${BASH_SOURCE}@${LINENO}: ';
648 set -x
649 debug=yes
650}
651
c5a65990 652[[ $dracutbasedir ]] || dracutbasedir=/usr/lib/dracut
5d791c0e 653
f1336ac7 654# if we were not passed a config file, try the default one
42c71947 655if [[ ! -f $conffile ]]; then
b093aa2d
HH
656 if [[ $allowlocal ]]; then
657 conffile="$dracutbasedir/dracut.conf"
658 else
eebc929a 659 conffile="/etc/dracut.conf"
b093aa2d 660 fi
42c71947 661fi
f1336ac7 662
2c2c4580 663if [[ ! -d $confdir ]]; then
b093aa2d
HH
664 if [[ $allowlocal ]]; then
665 confdir="$dracutbasedir/dracut.conf.d"
666 else
eebc929a 667 confdir="/etc/dracut.conf.d"
b093aa2d 668 fi
2c2c4580
HH
669fi
670
2245f372
AB
671# source our config file
672[[ -f $conffile ]] && . "$conffile"
673
2c2c4580 674# source our config dir
335bc217 675for f in $(dropindirs_sort ".conf" "$confdir" "$dracutbasedir/dracut.conf.d"); do
a42b2b81
HH
676 [[ -e $f ]] && . "$f"
677done
2c2c4580 678
5f2baf7d 679DRACUT_PATH=${DRACUT_PATH:-/sbin /bin /usr/sbin /usr/bin}
eab9b75c
HH
680
681for i in $DRACUT_PATH; do
682 rl=$i
683 if [ -L "$i" ]; then
684 rl=$(readlink -f $i)
685 fi
686 if [[ "$NPATH" != *:$rl* ]] ; then
687 NPATH+=":$rl"
688 fi
689done
690export PATH="${NPATH#:}"
691unset NPATH
692
cb0913db
HH
693# these options add to the stuff in the config file
694(( ${#add_dracutmodules_l[@]} )) && add_dracutmodules+=" ${add_dracutmodules_l[@]} "
695(( ${#force_add_dracutmodules_l[@]} )) && force_add_dracutmodules+=" ${force_add_dracutmodules_l[@]} "
696(( ${#fscks_l[@]} )) && fscks+=" ${fscks_l[@]} "
697(( ${#add_fstab_l[@]} )) && add_fstab+=" ${add_fstab_l[@]} "
698(( ${#fstab_lines_l[@]} )) && fstab_lines+=( "${fstab_lines_l[@]}" )
699(( ${#install_items_l[@]} )) && install_items+=" ${install_items_l[@]} "
700(( ${#install_optional_items_l[@]} )) && install_optional_items+=" ${install_optional_items_l[@]} "
54b68829 701
f1336ac7 702# these options override the stuff in the config file
cb0913db
HH
703(( ${#dracutmodules_l[@]} )) && dracutmodules="${dracutmodules_l[@]}"
704(( ${#omit_dracutmodules_l[@]} )) && omit_dracutmodules="${omit_dracutmodules_l[@]}"
705(( ${#filesystems_l[@]} )) && filesystems="${filesystems_l[@]}"
706(( ${#fw_dir_l[@]} )) && fw_dir="${fw_dir_l[@]}"
707(( ${#libdirs_l[@]} ))&& libdirs="${libdirs_l[@]}"
c9143a63 708
e103615b 709[[ $stdloglvl_l ]] && stdloglvl=$stdloglvl_l
b991617f 710[[ ! $stdloglvl ]] && stdloglvl=4
432196ae
711stdloglvl=$((stdloglvl + verbosity_mod_l))
712((stdloglvl > 6)) && stdloglvl=6
713((stdloglvl < 0)) && stdloglvl=0
714
26537a5b 715[[ $drivers_dir_l ]] && drivers_dir=$drivers_dir_l
31f7db66 716[[ $do_strip_l ]] && do_strip=$do_strip_l
6c128565 717[[ $do_strip ]] || do_strip=yes
f4a94278
HH
718[[ $do_prelink_l ]] && do_prelink=$do_prelink_l
719[[ $do_prelink ]] || do_prelink=yes
04d18f55
HH
720[[ $do_hardlink_l ]] && do_hardlink=$do_hardlink_l
721[[ $do_hardlink ]] || do_hardlink=yes
fd786adc
HH
722[[ $prefix_l ]] && prefix=$prefix_l
723[[ $prefix = "/" ]] && unset prefix
ba726310 724[[ $hostonly_l ]] && hostonly=$hostonly_l
ab9457ef 725[[ $hostonly_cmdline_l ]] && hostonly_cmdline=$hostonly_cmdline_l
30f6c80d 726[[ "$hostonly" == "yes" ]] && ! [[ $hostonly_cmdline ]] && hostonly_cmdline="yes"
b73e00af 727[[ $i18n_install_all_l ]] && i18n_install_all=$i18n_install_all_l
3411ad66 728[[ $persistent_policy_l ]] && persistent_policy=$persistent_policy_l
7c179686 729[[ $use_fstab_l ]] && use_fstab=$use_fstab_l
2f02ae9d 730[[ $mdadmconf_l ]] && mdadmconf=$mdadmconf_l
7a34efa5 731[[ $lvmconf_l ]] && lvmconf=$lvmconf_l
c5a65990 732[[ $dracutbasedir ]] || dracutbasedir=/usr/lib/dracut
794b2d2c 733[[ $fw_dir ]] || fw_dir="/lib/firmware/updates:/lib/firmware:/lib/firmware/$kernel"
882c4c5a
734[[ $tmpdir_l ]] && tmpdir="$tmpdir_l"
735[[ $tmpdir ]] || tmpdir=/var/tmp
871c8e40 736[[ $INITRD_COMPRESS ]] && compress=$INITRD_COMPRESS
3a714439 737[[ $compress_l ]] && compress=$compress_l
956af8f2 738[[ $show_modules_l ]] && show_modules=$show_modules_l
25b45979 739[[ $nofscks_l ]] && nofscks="yes"
ff3953ef 740[[ $ro_mnt_l ]] && ro_mnt="yes"
b7c770e1
DS
741[[ $early_microcode_l ]] && early_microcode=$early_microcode_l
742[[ $early_microcode ]] || early_microcode=no
ee54b840 743[[ $logfile_l ]] && logfile="$logfile_l"
80626ded 744[[ $reproducible_l ]] && reproducible="$reproducible_l"
37383f71 745[[ $loginstall_l ]] && loginstall="$loginstall_l"
636d2d46
HH
746[[ $uefi_stub_l ]] && uefi_stub="$uefi_stub_l"
747[[ $kernel_image_l ]] && kernel_image="$kernel_image_l"
5c57209b
HH
748[[ $machine_id_l ]] && machine_id="$machine_id_l"
749
750if ! [[ $outfile ]]; then
751 if [[ $machine_id != "no" ]]; then
752 [[ -f /etc/machine-id ]] && read MACHINE_ID < /etc/machine-id
753 fi
754
755 if [[ $uefi == "yes" ]]; then
756 BUILD_ID=$(cat /etc/os-release /usr/lib/os-release \
757 | while read -r line || [[ $line ]]; do \
758 [[ $line =~ BUILD_ID\=* ]] && eval "$line" && echo "$BUILD_ID" && break; \
759 done)
760 if [[ -d /efi ]] && mountpoint -q /efi; then
761 efidir=/efi
762 else
763 efidir=/boot/EFI
764 if [[ -d /boot/efi/EFI ]] && mountpoint -q /boot/efi; then
765 efidir=/boot/efi/EFI
766 fi
767 fi
768 mkdir -p "$efidir/Linux"
769 outfile="$efidir/Linux/linux-$kernel${MACHINE_ID:+-${MACHINE_ID}}${BUILD_ID:+-${BUILD_ID}}.efi"
770 else
771 if [[ $MACHINE_ID ]] && ( [[ -d /boot/${MACHINE_ID} ]] || [[ -L /boot/${MACHINE_ID} ]] ); then
772 outfile="/boot/${MACHINE_ID}/$kernel/initrd"
773 else
774 outfile="/boot/initramfs-$kernel.img"
775 fi
776 fi
777fi
80626ded 778
ddfd1d10 779# eliminate IFS hackery when messing with fw_dir
794b2d2c 780export DRACUT_FIRMWARE_PATH=${fw_dir// /:}
ddfd1d10 781fw_dir=${fw_dir//:/ }
9a8a00cf 782
3838dc47 783# check for logfile and try to create one if it doesn't exist
784if [[ -n "$logfile" ]];then
785 if [[ ! -f "$logfile" ]];then
786 touch "$logfile"
787 if [ ! $? -eq 0 ] ;then
788 printf "%s\n" "dracut: touch $logfile failed." >&2
789 fi
790 fi
791fi
792
3a714439 793# handle compression options.
693b7a32
HH
794if [[ $_no_compress_l = "cat" ]]; then
795 compress="cat"
796fi
797
798if ! [[ $compress ]]; then
799 # check all known compressors, if none specified
800 for i in pigz gzip lz4 lzop lzma xz lbzip2 bzip2 cat; do
801 command -v "$i" &>/dev/null || continue
802 compress="$i"
803 break
804 done
805 if [[ $compress = cat ]]; then
806 printf "%s\n" "dracut: no compression tool available. Initramfs image is going to be big." >&2
807 fi
808fi
809
810# choose the right arguments for the compressor
3a714439 811case $compress in
693b7a32
HH
812 bzip2|lbzip2)
813 if [[ "$compress" = lbzip2 ]] || command -v lbzip2 &>/dev/null; then
814 compress="lbzip2 -9"
815 else
816 compress="bzip2 -9"
817 fi
818 ;;
819 lzma)
820 compress="lzma -9 -T0"
821 ;;
822 xz)
823 compress="xz --check=crc32 --lzma2=dict=1MiB -T0"
824 ;;
825 gzip|pigz)
826 if [[ "$compress" = pigz ]] || command -v pigz &>/dev/null; then
66fd7e43 827 compress="pigz -9 -n -T -R"
693b7a32 828 elif command -v gzip &>/dev/null && gzip --help 2>&1 | grep -q rsyncable; then
66fd7e43 829 compress="gzip -n -9 --rsyncable"
693b7a32
HH
830 else
831 compress="gzip -n -9"
66fd7e43
HH
832 fi
833 ;;
693b7a32
HH
834 lzo|lzop)
835 compress="lzop -9"
836 ;;
837 lz4)
838 compress="lz4 -l -9"
839 ;;
3a714439 840esac
3a714439 841
ba726310 842[[ $hostonly = yes ]] && hostonly="-h"
ba67b923 843[[ $hostonly != "-h" ]] && unset hostonly
ba726310 844
80626ded
HH
845[[ $reproducible == yes ]] && DRACUT_REPRODUCIBLE=1
846
bafc82e7
DD
847readonly TMPDIR="$(realpath -e "$tmpdir")"
848[ -d "$TMPDIR" ] || {
849 printf "%s\n" "dracut: Invalid tmpdir '$tmpdir'." >&2
850 exit 1
851}
62c00a88
HH
852readonly DRACUT_TMPDIR="$(mktemp -p "$TMPDIR/" -d -t dracut.XXXXXX)"
853[ -d "$DRACUT_TMPDIR" ] || {
854 printf "%s\n" "dracut: mktemp -p '$TMPDIR/' -d -t dracut.XXXXXX failed." >&2
26c231f1
HH
855 exit 1
856}
857
d008b6b8 858# clean up after ourselves no matter how we die.
bbaa0d59
HH
859trap '
860 ret=$?;
62c00a88 861 [[ $keep ]] && echo "Not removing $DRACUT_TMPDIR." >&2 || { [[ $DRACUT_TMPDIR ]] && rm -rf -- "$DRACUT_TMPDIR"; };
bbaa0d59
HH
862 exit $ret;
863 ' EXIT
864
d008b6b8
HH
865# clean up after ourselves no matter how we die.
866trap 'exit 1;' SIGINT
867
3889234f
HH
868readonly initdir="${DRACUT_TMPDIR}/initramfs"
869mkdir "$initdir"
870
871if [[ $early_microcode = yes ]] || ( [[ $acpi_override = yes ]] && [[ -d $acpi_table_dir ]] ); then
872 readonly early_cpio_dir="${DRACUT_TMPDIR}/earlycpio"
873 mkdir "$early_cpio_dir"
874fi
875
89d44e72
HH
876export DRACUT_RESOLVE_LAZY="1"
877
535f61ca
HH
878if [[ $print_cmdline ]]; then
879 stdloglvl=0
880 sysloglvl=0
881 fileloglvl=0
882 kmsgloglvl=0
883fi
884
e27ecc9a
HH
885if [[ -f $dracutbasedir/dracut-version.sh ]]; then
886 . $dracutbasedir/dracut-version.sh
887fi
888
777f2db0
HH
889if [[ -f $dracutbasedir/dracut-init.sh ]]; then
890 . $dracutbasedir/dracut-init.sh
adbc8a42 891else
777f2db0 892 printf "%s\n" "dracut: Cannot find $dracutbasedir/dracut-init.sh." >&2
b093aa2d 893 printf "%s\n" "dracut: Are you running from a git checkout?" >&2
e8f19bcf 894 printf "%s\n" "dracut: Try passing -l as an argument to $dracut_cmd" >&2
cc02093d 895 exit 1
adbc8a42 896fi
22fd1627 897
106255af
HH
898if [[ $no_kernel != yes ]] && ! [[ -d $srcmods ]]; then
899 printf "%s\n" "dracut: Cannot find module directory $srcmods" >&2
900 printf "%s\n" "dracut: and --no-kernel was not specified" >&2
901 exit 1
902fi
903
1743473b
HH
904if ! [[ $print_cmdline ]]; then
905 inst /bin/sh
ffc68f35 906 if ! $DRACUT_INSTALL ${initdir:+-D "$initdir"} -R "$initdir/bin/sh" &>/dev/null; then
1743473b
HH
907 unset DRACUT_RESOLVE_LAZY
908 export DRACUT_RESOLVE_DEPS=1
909 fi
910 rm -fr -- ${initdir}/*
bfd2e8c2 911fi
bfd2e8c2 912
552ecca6 913dracutfunctions=$dracutbasedir/dracut-functions.sh
5cad5bb5 914export dracutfunctions
9a8a00cf 915
cb0913db 916(( ${#drivers_l[@]} )) && drivers="${drivers_l[@]}"
fcbcb252
HH
917drivers=${drivers/-/_}
918
cb0913db 919(( ${#add_drivers_l[@]} )) && add_drivers+=" ${add_drivers_l[@]} "
fcbcb252
HH
920add_drivers=${add_drivers/-/_}
921
cb0913db 922(( ${#force_drivers_l[@]} )) && force_drivers+=" ${force_drivers_l[@]} "
cea907f6
TR
923force_drivers=${force_drivers/-/_}
924
cb0913db 925(( ${#omit_drivers_l[@]} )) && omit_drivers+=" ${omit_drivers_l[@]} "
fcbcb252
HH
926omit_drivers=${omit_drivers/-/_}
927
cb0913db 928(( ${#kernel_cmdline_l[@]} )) && kernel_cmdline+=" ${kernel_cmdline_l[@]} "
d20fb951 929
34248c92 930omit_drivers_corrected=""
fcbcb252 931for d in $omit_drivers; do
b093aa2d 932 [[ " $drivers $add_drivers " == *\ $d\ * ]] && continue
cea907f6 933 [[ " $drivers $force_drivers " == *\ $d\ * ]] && continue
34248c92 934 omit_drivers_corrected+="$d|"
fcbcb252 935done
34248c92 936omit_drivers="${omit_drivers_corrected%|}"
fcbcb252
HH
937unset omit_drivers_corrected
938
ffa71b4a
HH
939# prepare args for logging
940for ((i=0; i < ${#dracut_args[@]}; i++)); do
b093aa2d 941 [[ "${dracut_args[$i]}" == *\ * ]] && \
ffa71b4a 942 dracut_args[$i]="\"${dracut_args[$i]}\""
a4210166 943 #" keep vim happy
ffa71b4a 944done
535f61ca 945
e8f19bcf 946dinfo "Executing: $dracut_cmd ${dracut_args[@]}"
58dad702 947
5b11bb73
HH
948[[ $do_list = yes ]] && {
949 for mod in $dracutbasedir/modules.d/*; do
950 [[ -d $mod ]] || continue;
d8e8e14e
951 [[ -e $mod/install || -e $mod/installkernel || \
952 -e $mod/module-setup.sh ]] || continue
b093aa2d 953 printf "%s\n" "${mod##*/??}"
5b11bb73
HH
954 done
955 exit 0
956}
957
66ac3cd1 958# This is kinda legacy -- eventually it should go away.
f1336ac7 959case $dracutmodules in
66ac3cd1 960 ""|auto) dracutmodules="all" ;;
f1336ac7 961esac
e12aac5e 962
454771cd 963abs_outfile=$(readlink -f "$outfile") && outfile="$abs_outfile"
ec9315e5 964
693b7a32
HH
965if [[ $no_kernel != yes ]] && [[ -d $srcmods ]]; then
966 if ! [[ -f $srcmods/modules.dep ]]; then
b019952f
HH
967 if [[ -n "$(find "$srcmods" -name '*.ko*')" ]]; then
968 dfatal "$srcmods/modules.dep is missing. Did you run depmod?"
969 exit 1
970 else
971 dwarn "$srcmods/modules.dep is missing. Did you run depmod?"
972 fi
693b7a32
HH
973 elif ! ( command -v gzip &>/dev/null && command -v xz &>/dev/null); then
974 read _mod < $srcmods/modules.dep
975 _mod=${_mod%%:*}
976 if [[ -f $srcmods/"$_mod" ]]; then
977 # Check, if kernel modules are compressed, and if we can uncompress them
978 case "$_mod" in
979 *.ko.gz) kcompress=gzip;;
980 *.ko.xz) kcompress=xz;;
981 esac
982 if [[ $kcompress ]]; then
983 if ! command -v "$kcompress" &>/dev/null; then
984 dfatal "Kernel modules are compressed with $kcompress, but $kcompress is not available."
985 exit 1
986 fi
987 fi
988 fi
989 fi
5db6ca5a 990fi
fe1484f3 991
96cf7270
HH
992if [[ ! $print_cmdline ]]; then
993 if [[ -f $outfile && ! $force ]]; then
994 dfatal "Will not override existing initramfs ($outfile) without --force"
995 exit 1
996 fi
997
998 outdir=${outfile%/*}
999 [[ $outdir ]] || outdir="/"
1000
1001 if [[ ! -d "$outdir" ]]; then
1002 dfatal "Can't write to $outdir: Directory $outdir does not exist or is not accessible."
1003 exit 1
1004 elif [[ ! -w "$outdir" ]]; then
1005 dfatal "No permission to write to $outdir."
1006 exit 1
1007 elif [[ -f "$outfile" && ! -w "$outfile" ]]; then
1008 dfatal "No permission to write $outfile."
1009 exit 1
1010 fi
37383f71
HH
1011
1012 if [[ $loginstall ]]; then
1013 if ! mkdir -p "$loginstall"; then
1014 dfatal "Could not create directory to log installed files to '$loginstall'."
1015 exit 1
1016 fi
1017 loginstall=$(readlink -f "$loginstall")
1018 fi
636d2d46
HH
1019
1020 if [[ $uefi = yes ]]; then
1021 if ! command -v objcopy &>/dev/null; then
1022 dfatal "Need 'objcopy' to create a UEFI executable"
1023 exit 1
1024 fi
1025 unset EFI_MACHINE_TYPE_NAME
1026 case $(arch) in
1027 x86_64)
1028 EFI_MACHINE_TYPE_NAME=x64;;
1029 ia32)
1030 EFI_MACHINE_TYPE_NAME=ia32;;
1031 *)
1032 dfatal "Architecture '$(arch)' not supported to create a UEFI executable"
1033 exit 1
1034 ;;
1035 esac
1036
1037 if ! [[ -s $uefi_stub ]]; then
1038 for uefi_stub in \
53475faa 1039 "${systemdutildir}/boot/efi/linux${EFI_MACHINE_TYPE_NAME}.efi.stub" \
636d2d46
HH
1040 "/usr/lib/gummiboot/linux${EFI_MACHINE_TYPE_NAME}.efi.stub"; do
1041 [[ -s $uefi_stub ]] || continue
1042 break
1043 done
1044 fi
1045 if ! [[ -s $uefi_stub ]]; then
1046 dfatal "Can't find a uefi stub '$uefi_stub' to create a UEFI executable"
1047 exit 1
1048 fi
1049
1050 if ! [[ $kernel_image ]]; then
1051 for kernel_image in "/lib/modules/$kernel/vmlinuz" "/boot/vmlinuz-$kernel"; do
1052 [[ -s "$kernel_image" ]] || continue
1053 break
1054 done
1055 fi
1056 if ! [[ -s $kernel_image ]]; then
1057 dfatal "Can't find a kernel image '$kernel_image' to create a UEFI executable"
1058 exit 1
1059 fi
1060 fi
ec9315e5
JK
1061fi
1062
940169e8
HH
1063if [[ $acpi_override = yes ]] && ! ( check_kernel_config CONFIG_ACPI_TABLE_UPGRADE || check_kernel_config CONFIG_ACPI_INITRD_TABLE_OVERRIDE ); then
1064 dwarn "Disabling ACPI override, because kernel does not support it. CONFIG_ACPI_INITRD_TABLE_OVERRIDE!=y or CONFIG_ACPI_TABLE_UPGRADE!=y"
8e3f6537
HH
1065 unset acpi_override
1066fi
1067
1068if [[ $early_microcode = yes ]]; then
1069 if [[ $hostonly ]]; then
1070 [[ $(get_cpu_vendor) == "AMD" ]] \
875426f2 1071 && ! check_kernel_config CONFIG_MICROCODE_AMD \
8e3f6537
HH
1072 && unset early_microcode
1073 [[ $(get_cpu_vendor) == "Intel" ]] \
875426f2 1074 && ! check_kernel_config CONFIG_MICROCODE_INTEL \
8e3f6537
HH
1075 && unset early_microcode
1076 else
875426f2
HH
1077 ! check_kernel_config CONFIG_MICROCODE_AMD \
1078 && ! check_kernel_config CONFIG_MICROCODE_INTEL \
8e3f6537
HH
1079 && unset early_microcode
1080 fi
1081 [[ $early_microcode != yes ]] \
875426f2 1082 && dwarn "Disabling early microcode, because kernel does not support it. CONFIG_MICROCODE_[AMD|INTEL]!=y"
8e3f6537
HH
1083fi
1084
f6f74096
DD
1085# Need to be able to have non-root users read stuff (rpcbind etc)
1086chmod 755 "$initdir"
1087
5bfa3b36
HH
1088if [[ $hostonly ]]; then
1089 for i in /sys /proc /run /dev; do
5e601454 1090 if ! findmnt --target "$i" &>/dev/null; then
5bfa3b36
HH
1091 dwarning "Turning off host-only mode: '$i' is not mounted!"
1092 unset hostonly
1093 fi
1094 done
1095fi
1096
d351541e
HH
1097declare -A host_fs_types
1098
cd7ff122
AW
1099for line in "${fstab_lines[@]}"; do
1100 set -- $line
6df52351 1101 dev="$1"
cd7ff122 1102 #dev mp fs fsopts
6df52351
TR
1103 case "$dev" in
1104 UUID=*)
1105 dev=$(blkid -l -t UUID=${dev#UUID=} -o device)
1106 ;;
1107 LABEL=*)
1108 dev=$(blkid -l -t LABEL=${dev#LABEL=} -o device)
1109 ;;
1110 PARTUUID=*)
1111 dev=$(blkid -l -t PARTUUID=${dev#PARTUUID=} -o device)
1112 ;;
1113 PARTLABEL=*)
1114 dev=$(blkid -l -t PARTLABEL=${dev#PARTLABEL=} -o device)
1115 ;;
1116 esac
1117 [ -z "$dev" ] && dwarn "Bad fstab entry $@" && continue
1cadc26f
HH
1118 if [[ "$3" == btrfs ]]; then
1119 for i in $(btrfs_devs "$2"); do
1120 push_host_devs "$i"
1121 done
1122 fi
6df52351
TR
1123 push_host_devs "$dev"
1124 host_fs_types["$dev"]="$3"
cd7ff122
AW
1125done
1126
1127for f in $add_fstab; do
b093aa2d 1128 [[ -e $f ]] || continue
6d58fa27 1129 while read dev rest || [ -n "$dev" ]; do
118ca9ec 1130 push_host_devs "$dev"
b093aa2d
HH
1131 done < "$f"
1132done
1133
1134for dev in $add_device; do
118ca9ec 1135 push_host_devs "$dev"
cd7ff122
AW
1136done
1137
c586b033 1138if (( ${#add_device_l[@]} )); then
694725ab
HH
1139 add_device+=" ${add_device_l[@]} "
1140 push_host_devs "${add_device_l[@]}"
c586b033
CG
1141fi
1142
37f2fe55 1143if [[ $hostonly ]] && [[ "$hostonly_default_device" != "no" ]]; then
480d772f
HH
1144 # in hostonly mode, determine all devices, which have to be accessed
1145 # and examine them for filesystem types
1146
bcfbddef 1147 for mp in \
7ae5d9d1
HH
1148 "/" \
1149 "/etc" \
d624f606
HH
1150 "/bin" \
1151 "/sbin" \
1152 "/lib" \
1153 "/lib64" \
af75a298 1154 "/usr" \
9fc14445
HH
1155 "/usr/bin" \
1156 "/usr/sbin" \
1157 "/usr/lib" \
1158 "/usr/lib64" \
a956a464
HH
1159 "/boot" \
1160 "/boot/efi" \
1161 ;
bcfbddef 1162 do
d624f606 1163 mp=$(readlink -f "$mp")
7ae5d9d1 1164 mountpoint "$mp" >/dev/null 2>&1 || continue
a4f7b504 1165 _dev=$(find_block_device "$mp")
e95b6723 1166 _bdev=$(readlink -f "/dev/block/$_dev")
a4f7b504 1167 [[ -b $_bdev ]] && _dev=$_bdev
5a66d511 1168 [[ "$mp" == "/" ]] && root_devs+=("$_dev")
118ca9ec 1169 push_host_devs "$_dev"
1cadc26f
HH
1170 if [[ $(find_mp_fstype "$mp") == btrfs ]]; then
1171 for i in $(btrfs_devs "$mp"); do
5a66d511 1172 [[ "$mp" == "/" ]] && root_devs+=("$i")
1cadc26f
HH
1173 push_host_devs "$i"
1174 done
1175 fi
7ae5d9d1 1176 done
dd587549 1177
7fd850d5 1178 if [[ -f /proc/swaps ]] && [[ -f /etc/fstab ]]; then
6d58fa27 1179 while read dev type rest || [ -n "$dev" ]; do
7fd850d5
HH
1180 [[ -b $dev ]] || continue
1181 [[ "$type" == "partition" ]] || continue
1182
6d58fa27 1183 while read _d _m _t _o _r || [ -n "$_d" ]; do
7fd850d5
HH
1184 [[ "$_d" == \#* ]] && continue
1185 [[ $_d ]] || continue
546d5dac
HH
1186 [[ $_t != "swap" ]] && continue
1187 [[ $_m != "swap" ]] && [[ $_m != "none" ]] && continue
7fd850d5 1188 [[ "$_o" == *noauto* ]] && continue
c82a1133 1189 _d=$(expand_persistent_dev "$_d")
7fd850d5
HH
1190 [[ "$_d" -ef "$dev" ]] || continue
1191
1192 if [[ -f /etc/crypttab ]]; then
6d58fa27 1193 while read _mapper _a _p _o || [ -n "$_mapper" ]; do
7fd850d5
HH
1194 [[ $_mapper = \#* ]] && continue
1195 [[ "$_d" -ef /dev/mapper/"$_mapper" ]] || continue
1196 [[ "$_o" ]] || _o="$_p"
64ae4e07
HH
1197 # skip entries with password files
1198 [[ "$_p" == /* ]] && [[ -f $_p ]] && continue 2
1743473b 1199 # skip mkswap swap
7fd850d5
HH
1200 [[ $_o == *swap* ]] && continue 2
1201 done < /etc/crypttab
1202 fi
bcfbddef 1203
3e3ed34f
CG
1204 _dev="$(readlink -f "$dev")"
1205 push_host_devs "$_dev"
5a66d511 1206 swap_devs+=("$_dev")
7fd850d5
HH
1207 break
1208 done < /etc/fstab
1209 done < /proc/swaps
1210 fi
916559e0
HH
1211
1212 # collect all "x-initrd.mount" entries from /etc/fstab
1213 if [[ -f /etc/fstab ]]; then
1214 while read _d _m _t _o _r || [ -n "$_d" ]; do
1215 [[ "$_d" == \#* ]] && continue
1216 [[ $_d ]] || continue
1217 [[ "$_o" != *x-initrd.mount* ]] && continue
1218 _dev=$(expand_persistent_dev "$_d")
1219 _dev="$(readlink -f "$_dev")"
1cadc26f
HH
1220 [[ -b $_dev ]] || continue
1221
1222 push_host_devs "$_dev"
1223 if [[ "$_t" == btrfs ]]; then
1224 for i in $(find_btrfs_devs "$_m"); do
1225 push_host_devs "$i"
1226 done
1227 fi
916559e0
HH
1228 done < /etc/fstab
1229 fi
7ae5d9d1 1230fi
7ae5d9d1 1231
3c4315fa
HH
1232unset m
1233unset rest
1234
dba20559 1235_get_fs_type() {
19bab59c 1236 [[ $1 ]] || return
e41f3f90
HH
1237 if [[ -b /dev/block/$1 ]]; then
1238 ID_FS_TYPE=$(get_fs_env "/dev/block/$1") && host_fs_types["$(readlink -f "/dev/block/$1")"]="$ID_FS_TYPE"
19bab59c 1239 return 1
cd7ff122 1240 fi
e41f3f90
HH
1241 if [[ -b $1 ]]; then
1242 ID_FS_TYPE=$(get_fs_env "$1") && host_fs_types["$(readlink -f "$1")"]="$ID_FS_TYPE"
19bab59c 1243 return 1
4f10ae2b 1244 fi
b093aa2d 1245 if fstype=$(find_dev_fstype "$1"); then
dba20559 1246 host_fs_types["$1"]="$fstype"
19bab59c 1247 return 1
cd7ff122
AW
1248 fi
1249 return 1
dba20559
HH
1250}
1251
3721635b 1252for dev in "${host_devs[@]}"; do
dba20559
HH
1253 _get_fs_type "$dev"
1254 check_block_and_slaves_all _get_fs_type "$(get_maj_min "$dev")"
cd7ff122
AW
1255done
1256
8df0b654
HH
1257for dev in "${!host_fs_types[@]}"; do
1258 [[ ${host_fs_types[$dev]} = "reiserfs" ]] || [[ ${host_fs_types[$dev]} = "xfs" ]] || continue
1259 rootopts=$(find_dev_fsopts "$dev")
1260 if [[ ${host_fs_types[$dev]} = "reiserfs" ]]; then
1261 journaldev=$(fs_get_option $rootopts "jdev")
1262 elif [[ ${host_fs_types[$dev]} = "xfs" ]]; then
1263 journaldev=$(fs_get_option $rootopts "logdev")
1264 fi
1265 if [[ $journaldev ]]; then
1266 dev="$(readlink -f "$dev")"
118ca9ec 1267 push_host_devs "$dev"
8df0b654
HH
1268 _get_fs_type "$dev"
1269 check_block_and_slaves_all _get_fs_type "$(get_maj_min "$dev")"
1270 fi
1271done
1272
d1615612 1273[[ -d $udevdir ]] \
b093aa2d 1274 || udevdir="$(pkg-config udev --variable=udevdir 2>/dev/null)"
d1615612 1275if ! [[ -d "$udevdir" ]]; then
80dab03a 1276 [[ ! -h /lib ]] && [[ -d /lib/udev ]] && udevdir=/lib/udev
d1615612
HH
1277 [[ -d /usr/lib/udev ]] && udevdir=/usr/lib/udev
1278fi
1279
1280[[ -d $systemdutildir ]] \
1281 || systemdutildir=$(pkg-config systemd --variable=systemdutildir 2>/dev/null)
d1615612
HH
1282
1283if ! [[ -d "$systemdutildir" ]]; then
80dab03a 1284 [[ ! -h /lib ]] && [[ -d /lib/systemd ]] && systemdutildir=/lib/systemd
d1615612
HH
1285 [[ -d /usr/lib/systemd ]] && systemdutildir=/usr/lib/systemd
1286fi
cb8def95
HH
1287
1288[[ -d $systemdsystemunitdir ]] \
1289 || systemdsystemunitdir=$(pkg-config systemd --variable=systemdsystemunitdir 2>/dev/null)
1290
d1615612
HH
1291[[ -d "$systemdsystemunitdir" ]] || systemdsystemunitdir=${systemdutildir}/system
1292
cb8def95
HH
1293[[ -d $systemdsystemconfdir ]] \
1294 || systemdsystemconfdir=$(pkg-config systemd --variable=systemdsystemconfdir 2>/dev/null)
1295
1296[[ -d "$systemdsystemconfdir" ]] || systemdsystemconfdir=/etc/systemd/system
1297
3a04bdde
HH
1298[[ -d $tmpfilesdir ]] \
1299 || tmpfilesdir=$(pkg-config systemd --variable=tmpfilesdir 2>/dev/null)
1300
1301if ! [[ -d "$tmpfilesdir" ]]; then
55b99a0e
CG
1302 [[ -d /lib/tmpfiles.d ]] && tmpfilesdir=/lib/tmpfiles.d
1303 [[ -d /usr/lib/tmpfiles.d ]] && tmpfilesdir=/usr/lib/tmpfiles.d
3a04bdde
HH
1304fi
1305
ab2f95e4
HH
1306export initdir dracutbasedir \
1307 dracutmodules force_add_dracutmodules add_dracutmodules omit_dracutmodules \
1308 mods_to_load \
e103615b 1309 fw_dir drivers_dir debug no_kernel kernel_only \
5634a311 1310 omit_drivers mdadmconf lvmconf root_devs \
ff3953ef 1311 use_fstab fstab_lines libdirs fscks nofscks ro_mnt \
1e64e493 1312 stdloglvl sysloglvl fileloglvl kmsgloglvl logfile \
3e3ed34f 1313 debug host_fs_types host_devs swap_devs sshkey add_fstab \
cb8def95 1314 DRACUT_VERSION udevdir prefix filesystems drivers \
3c4315fa 1315 systemdutildir systemdsystemunitdir systemdsystemconfdir \
3f60444e 1316 hostonly_cmdline loginstall \
3a04bdde 1317 tmpfilesdir
f4fff04e 1318
1743473b
HH
1319mods_to_load=""
1320# check all our modules to see if they should be sourced.
1321# This builds a list of modules that we will install next.
1322for_each_module_dir check_module
1323for_each_module_dir check_mount
1324
88c86ac7 1325dracut_module_included "fips" && export DRACUT_FIPS_MODE=1
1743473b 1326
91190597
HH
1327do_print_cmdline()
1328{
21a20973
HH
1329 local -A _mods_to_print
1330 for i in $modules_loaded $mods_to_load; do
1331 _mods_to_print[$i]=1
1332 done
1333
1743473b
HH
1334 # source our modules.
1335 for moddir in "$dracutbasedir/modules.d"/[0-9][0-9]*; do
1336 _d_mod=${moddir##*/}; _d_mod=${_d_mod#[0-9][0-9]}
21a20973 1337 [[ ${_mods_to_print[$_d_mod]} ]] || continue
1743473b
HH
1338 module_cmdline "$_d_mod"
1339 done
1340 unset moddir
91190597
HH
1341}
1342
1343if [[ $print_cmdline ]]; then
1344 do_print_cmdline
a17d5cf4 1345 printf "\n"
1743473b
HH
1346 exit 0
1347fi
1348
dbad9f46 1349# Create some directory structure first
fd786adc 1350[[ $prefix ]] && mkdir -m 0755 -p "${initdir}${prefix}"
dbad9f46 1351
785a6cd2 1352[[ -h /lib ]] || mkdir -m 0755 -p "${initdir}${prefix}/lib"
fd786adc 1353[[ $prefix ]] && ln -sfn "${prefix#/}/lib" "$initdir/lib"
dbad9f46 1354
785a6cd2 1355if [[ $prefix ]]; then
d2a9c4a8 1356 for d in bin etc lib sbin tmp usr var $libdirs; do
b093aa2d 1357 [[ "$d" == */* ]] && continue
785a6cd2
HH
1358 ln -sfn "${prefix#/}/${d#/}" "$initdir/$d"
1359 done
1360fi
1361
1362if [[ $kernel_only != yes ]]; then
6f92423c 1363 for d in usr/bin usr/sbin bin etc lib sbin tmp usr var var/tmp $libdirs; do
fd786adc 1364 [[ -e "${initdir}${prefix}/$d" ]] && continue
d433da44
HH
1365 if [ -L "/$d" ]; then
1366 inst_symlink "/$d" "${prefix}/$d"
785a6cd2
HH
1367 else
1368 mkdir -m 0755 -p "${initdir}${prefix}/$d"
1369 fi
3b403b32 1370 done
dbad9f46 1371
8d89fc6b 1372 for d in dev proc sys sysroot root run; do
d433da44
HH
1373 if [ -L "/$d" ]; then
1374 inst_symlink "/$d"
785a6cd2
HH
1375 else
1376 mkdir -m 0755 -p "$initdir/$d"
1377 fi
33ee031c 1378 done
dbad9f46 1379
506b2192
HH
1380 ln -sfn ../run "$initdir/var/run"
1381 ln -sfn ../run/lock "$initdir/var/lock"
6f09acf8
HH
1382else
1383 for d in lib "$libdir"; do
1384 [[ -e "${initdir}${prefix}/$d" ]] && continue
1385 if [ -h "/$d" ]; then
1386 inst "/$d" "${prefix}/$d"
1387 else
1388 mkdir -m 0755 -p "${initdir}${prefix}/$d"
1389 fi
1390 done
33ee031c 1391fi
0f86847d 1392
14c47b0e
HH
1393if [[ $kernel_only != yes ]]; then
1394 mkdir -p "${initdir}/etc/cmdline.d"
4fed3ddf
HH
1395 for _d in $hookdirs; do
1396 mkdir -m 0755 -p ${initdir}/lib/dracut/hooks/$_d
1397 done
647b521f 1398 if [[ "$EUID" = "0" ]]; then
ad200fbc
HH
1399 [ -c ${initdir}/dev/null ] || mknod ${initdir}/dev/null c 1 3
1400 [ -c ${initdir}/dev/kmsg ] || mknod ${initdir}/dev/kmsg c 1 11
1401 [ -c ${initdir}/dev/console ] || mknod ${initdir}/dev/console c 5 1
83a6d6f9
HH
1402 [ -c ${initdir}/dev/random ] || mknod ${initdir}/dev/random c 1 8
1403 [ -c ${initdir}/dev/urandom ] || mknod ${initdir}/dev/urandom c 1 9
26144216 1404 fi
14c47b0e 1405fi
96b8d60a 1406
ec3c5951 1407_isize=0 #initramfs size
979c4a93 1408modules_loaded=" "
95bde758 1409# source our modules.
5d791c0e 1410for moddir in "$dracutbasedir/modules.d"/[0-9][0-9]*; do
979c4a93 1411 _d_mod=${moddir##*/}; _d_mod=${_d_mod#[0-9][0-9]}
bee08653
HH
1412 [[ "$mods_to_load" == *\ $_d_mod\ * ]] || continue
1413 if [[ $show_modules = yes ]]; then
1414 printf "%s\n" "$_d_mod"
1415 else
1416 dinfo "*** Including module: $_d_mod ***"
1417 fi
1418 if [[ $kernel_only == yes ]]; then
1419 module_installkernel "$_d_mod" || {
1420 dfatal "installkernel failed in module $_d_mod"
1421 exit 1
1422 }
1423 else
1424 module_install "$_d_mod"
1425 if [[ $no_kernel != yes ]]; then
b093aa2d 1426 module_installkernel "$_d_mod" || {
a6d3be9d
AW
1427 dfatal "installkernel failed in module $_d_mod"
1428 exit 1
1429 }
ec3c5951 1430 fi
66ac3cd1 1431 fi
bee08653
HH
1432 mods_to_load=${mods_to_load// $_d_mod /}
1433 modules_loaded+="$_d_mod "
1434
1435 #print the module install size
1436 if [ -n "$printsize" ]; then
1437 _isize_new=$(du -sk ${initdir}|cut -f1)
1438 _isize_delta=$((_isize_new - _isize))
1439 printf "%s\n" "$_d_mod install size: ${_isize_delta}k"
1440 _isize=$_isize_new
1441 fi
15136762 1442done
20abd914 1443unset moddir
0a35a80b
HH
1444
1445for i in $modules_loaded; do
43fed151 1446 mkdir -p $initdir/lib/dracut
b093aa2d 1447 printf "%s\n" "$i" >> $initdir/lib/dracut/modules.txt
0a35a80b
HH
1448done
1449
ea216a65 1450dinfo "*** Including modules done ***"
aabc0553 1451
0f86847d 1452## final stuff that has to happen
89d44e72 1453if [[ $no_kernel != yes ]]; then
aec9f902
HH
1454
1455 if [[ $drivers ]]; then
1456 hostonly='' instmods $drivers
1457 fi
1458
1459 if [[ $add_drivers ]]; then
1460 hostonly='' instmods -c $add_drivers
1461 fi
cea907f6
TR
1462 if [[ $force_drivers ]]; then
1463 hostonly='' instmods -c $force_drivers
1464 rm -f $initdir/etc/cmdline.d/20-force_driver.conf
1465 for mod in $force_drivers; do
1466 echo "rd.driver.pre=$mod" >>$initdir/etc/cmdline.d/20-force_drivers.conf
1467 done
1468 fi
aec9f902
HH
1469 if [[ $filesystems ]]; then
1470 hostonly='' instmods -c $filesystems
1471 fi
1472
794b2d2c 1473 dinfo "*** Installing kernel module dependencies ***"
89d44e72 1474 dracut_kernel_post
794b2d2c 1475 dinfo "*** Installing kernel module dependencies done ***"
83bb0893
HH
1476
1477 if [[ $noimageifnotneeded == yes ]] && [[ $hostonly ]]; then
1478 if [[ ! -f "$initdir/lib/dracut/need-initqueue" ]] && \
1479 [[ -f ${initdir}/lib/modules/$kernel/modules.dep && ! -s ${initdir}/lib/modules/$kernel/modules.dep ]]; then
1480 for i in ${initdir}/etc/cmdline.d/*.conf; do
1481 # We need no initramfs image and do not generate one.
1482 [[ $i == "${initdir}/etc/cmdline.d/*.conf" ]] && exit 0
1483 done
1484 fi
1485 fi
89d44e72 1486fi
d8aeb3a7 1487
998bf6e0 1488if [[ $kernel_only != yes ]]; then
3c001899
HH
1489 (( ${#install_items[@]} > 0 )) && inst_multiple ${install_items[@]}
1490 (( ${#install_optional_items[@]} > 0 )) && inst_multiple -o ${install_optional_items[@]}
998bf6e0 1491
b093aa2d 1492 [[ $kernel_cmdline ]] && printf "%s\n" "$kernel_cmdline" >> "${initdir}/etc/cmdline.d/01-default.conf"
d20fb951 1493
694725ab 1494 for line in "${fstab_lines[@]}"; do
5f6a495b 1495 line=($line)
edbd9ca0
FV
1496
1497 if [ -z "${line[1]}" ]; then
1498 # Determine device and mount options from current system
1499 mountpoint -q "${line[0]}" || derror "${line[0]} is not a mount point!"
1500 line=($(findmnt --raw -n --target "${line[0]}" --output=source,target,fstype,options))
1501 dinfo "Line for ${line[1]}: ${line[@]}"
1502 else
1503 # Use default options
1504 [ -z "${line[3]}" ] && line[3]="defaults"
1505 fi
1506
1507 # Default options for freq and passno
5f6a495b
DY
1508 [ -z "${line[4]}" ] && line[4]="0"
1509 [ -z "${line[5]}" ] && line[5]="2"
edbd9ca0 1510
3586a7aa 1511 strstr "${line[2]}" "nfs" && line[5]="0"
5f6a495b 1512 echo "${line[@]}" >> "${initdir}/etc/fstab"
998bf6e0
HH
1513 done
1514
1515 for f in $add_fstab; do
b093aa2d 1516 cat "$f" >> "${initdir}/etc/fstab"
998bf6e0
HH
1517 done
1518
27d7936f 1519 if [[ $systemdutildir ]]; then
2da041d6
HH
1520 if [ -d ${initdir}/$systemdutildir ]; then
1521 mkdir -p ${initdir}/etc/conf.d
1522 {
1523 printf "%s\n" "systemdutildir=\"$systemdutildir\""
1524 printf "%s\n" "systemdsystemunitdir=\"$systemdsystemunitdir\""
1525 printf "%s\n" "systemdsystemconfdir=\"$systemdsystemconfdir\""
1526 } > ${initdir}/etc/conf.d/systemd.conf
1527 fi
6c6d8057
HH
1528 fi
1529
998bf6e0
HH
1530 if [[ $DRACUT_RESOLVE_LAZY ]] && [[ $DRACUT_INSTALL ]]; then
1531 dinfo "*** Resolving executable dependencies ***"
f182cb95 1532 find "$initdir" -type f -perm /0111 -not -path '*.ko' -print0 \
f7f5b82b 1533 | xargs -r -0 $DRACUT_INSTALL ${initdir:+-D "$initdir"} -R ${DRACUT_FIPS_MODE:+-f} --
998bf6e0
HH
1534 dinfo "*** Resolving executable dependencies done***"
1535 fi
8dcc4830
HH
1536
1537 # libpthread workaround: pthread_cancel wants to dlopen libgcc_s.so
1538 for _dir in $libdirs; do
1539 for _f in "$_dir/libpthread.so"*; do
1540 [[ -e "$_f" ]] || continue
1541 inst_libdir_file "libgcc_s.so*"
1542 break 2
1543 done
1544 done
998bf6e0
HH
1545fi
1546
694725ab
HH
1547for ((i=0; i < ${#include_src[@]}; i++)); do
1548 src="${include_src[$i]}"
1549 target="${include_target[$i]}"
c9364f6e 1550 if [[ $src && $target ]]; then
661f9a34 1551 if [[ -f $src ]]; then
c9364f6e 1552 inst $src $target
661f9a34 1553 else
3b403b32 1554 ddebug "Including directory: $src"
c9364f6e 1555 destdir="${initdir}/${target}"
332ecaa9 1556 mkdir -p "$destdir"
dbad9f46 1557 # check for preexisting symlinks, so we can cope with the
fd786adc 1558 # symlinks to $prefix
c9364f6e
EV
1559 # Objectname is a file or a directory
1560 for objectname in "$src"/*; do
1561 [[ -e "$objectname" || -h "$objectname" ]] || continue
1562 if [[ -d "$objectname" ]]; then
1563 # objectname is a directory, let's compute the final directory name
1564 object_destdir=${destdir}/${objectname#$src/}
1565 if ! [[ -e "$object_destdir" ]]; then
1566 mkdir -m 0755 -p "$object_destdir"
1567 chmod --reference="$objectname" "$object_destdir"
dbad9f46 1568 fi
7e51a94f 1569 $DRACUT_CP -t "$object_destdir" "$objectname"/*
dbad9f46 1570 else
7e51a94f 1571 $DRACUT_CP -t "$destdir" "$objectname"
3b403b32 1572 fi
dbad9f46 1573 done
661f9a34 1574 fi
4fea3ea6 1575 fi
661f9a34 1576done
88ffd2df 1577
14c47b0e 1578if [[ $kernel_only != yes ]]; then
1254925f
HH
1579 # make sure that library links are correct and up to date
1580 for f in /etc/ld.so.conf /etc/ld.so.conf.d/*; do
482c573d 1581 [[ -f $f ]] && inst_simple "$f"
1254925f
HH
1582 done
1583 if ! ldconfig -r "$initdir"; then
647b521f 1584 if [[ $EUID = 0 ]]; then
1254925f
HH
1585 derror "ldconfig exited ungracefully"
1586 else
1587 derror "ldconfig might need uid=0 (root) for chroot()"
1588 fi
432196ae
1589 fi
1590fi
fdc421db 1591
6cd7001b 1592PRELINK_BIN="$(command -v prelink)"
647b521f 1593if [[ $EUID = 0 ]] && [[ $PRELINK_BIN ]]; then
6cd7001b
HH
1594 if [[ $DRACUT_FIPS_MODE ]]; then
1595 dinfo "*** Installing prelink files ***"
1596 inst_multiple -o prelink /etc/prelink.conf /etc/prelink.conf.d/*.conf /etc/prelink.cache
1597 elif [[ $do_prelink == yes ]]; then
1598 dinfo "*** Pre-linking files ***"
1599 inst_multiple -o prelink /etc/prelink.conf /etc/prelink.conf.d/*.conf
1600 chroot "$initdir" "$PRELINK_BIN" -a
1601 rm -f -- "$initdir/$PRELINK_BIN"
1602 rm -fr -- "$initdir"/etc/prelink.*
1603 dinfo "*** Pre-linking files done ***"
404815ea
HH
1604 fi
1605fi
1606
1607if [[ $do_hardlink = yes ]] && command -v hardlink >/dev/null; then
1608 dinfo "*** Hardlinking files ***"
1609 hardlink "$initdir" 2>&1
1610 dinfo "*** Hardlinking files done ***"
1611fi
1612
3b403b32 1613# strip binaries
98adb06e 1614if [[ $do_strip = yes ]] ; then
8b6d136e
DM
1615 # Prefer strip from elfutils for package size
1616 declare strip_cmd=$(command -v eu-strip)
1617 test -z "$strip_cmd" && strip_cmd="strip"
1618
1619 for p in $strip_cmd xargs find; do
cc02093d 1620 if ! type -P $p >/dev/null; then
fefd3f66 1621 dinfo "Could not find '$p'. Not stripping the initramfs."
cc02093d
HH
1622 do_strip=no
1623 fi
31f7db66
HH
1624 done
1625fi
1626
5ae33613 1627if [[ $do_strip = yes ]] && ! [[ $DRACUT_FIPS_MODE ]]; then
89d44e72 1628 dinfo "*** Stripping files ***"
5ae33613
HH
1629 find "$initdir" -type f \
1630 -executable -not -path '*/lib/modules/*.ko' -print0 \
8b6d136e 1631 | xargs -r -0 $strip_cmd -g 2>/dev/null
2d9b156e
HH
1632
1633 # strip kernel modules, but do not touch signed modules
1634 find "$initdir" -type f -path '*/lib/modules/*.ko' -print0 \
6d58fa27 1635 | while read -r -d $'\0' f || [ -n "$f" ]; do
f0bfada3 1636 SIG=$(tail -c 28 "$f" | tr -d '\000')
b093aa2d 1637 [[ $SIG == '~Module signature appended~' ]] || { printf "%s\000" "$f"; }
8b6d136e 1638 done | xargs -r -0 $strip_cmd -g
2d9b156e 1639
89d44e72 1640 dinfo "*** Stripping files done ***"
979c4a93 1641fi
5f2c30d9
KRW
1642if [[ $early_microcode = yes ]]; then
1643 dinfo "*** Generating early-microcode cpio image ***"
1644 ucode_dir=(amd-ucode intel-ucode)
1645 ucode_dest=(AuthenticAMD.bin GenuineIntel.bin)
b5b608e4 1646 _dest_dir="$early_cpio_dir/d/kernel/x86/microcode"
5f2c30d9
KRW
1647 _dest_idx="0 1"
1648 mkdir -p $_dest_dir
1649 if [[ $hostonly ]]; then
1650 [[ $(get_cpu_vendor) == "AMD" ]] && _dest_idx="0"
1651 [[ $(get_cpu_vendor) == "Intel" ]] && _dest_idx="1"
1652 fi
1653 for idx in $_dest_idx; do
1654 _fw=${ucode_dir[$idx]}
1655 for _fwdir in $fw_dir; do
1656 if [[ -d $_fwdir && -d $_fwdir/$_fw ]]; then
1657 _src="*"
1658 dinfo "*** Constructing ${ucode_dest[$idx]} ****"
1659 if [[ $hostonly ]]; then
1660 _src=$(get_ucode_file)
b44156c6 1661 [[ $_src ]] || break
efba549a 1662 [[ -r $_fwdir/$_fw/$_src ]] || break
5f2c30d9 1663 fi
efba549a 1664
583fb231 1665 for i in $_fwdir/$_fw/$_src; do
efba549a 1666 [ -e "$i" ] && break
583fb231
HH
1667 break 2
1668 done
c44d2252
HH
1669 for i in $_fwdir/$_fw/$_src; do
1670 [[ -e "$i" ]] || continue
1671 # skip gpg files
1672 str_ends "$i" ".asc" && continue
1673 cat "$i" >> $_dest_dir/${ucode_dest[$idx]}
1674 done
d8b04dc1 1675 create_early_cpio="yes"
5f2c30d9
KRW
1676 fi
1677 done
1678 done
5f2c30d9 1679fi
bbaa0d59 1680
f3b14c2b
TR
1681if [[ $acpi_override = yes ]] && [[ -d $acpi_table_dir ]]; then
1682 dinfo "*** Packaging ACPI tables to override BIOS provided ones ***"
1683 _dest_dir="$early_cpio_dir/d/kernel/firmware/acpi"
1684 mkdir -p $_dest_dir
1685 for table in $acpi_table_dir/*.aml; do
1686 dinfo " Adding ACPI table: $table"
7e51a94f 1687 $DRACUT_CP $table $_dest_dir
f3b14c2b
TR
1688 create_early_cpio="yes"
1689 done
1690fi
1691
659dc319
HB
1692dinfo "*** Store current command line parameters ***"
1693if ! ( echo $PARMS_TO_STORE > $initdir/lib/dracut/build-parameter.txt ); then
1694 dfatal "Could not store the current command line parameters"
1695 exit 1
1696fi
1697
76dd870b 1698if [[ $hostonly_cmdline == "yes" ]] ; then
496e3d96 1699 unset _stored_cmdline
fe273e39
HR
1700 if [ -d $initdir/etc/cmdline.d ];then
1701 dinfo "Stored kernel commandline:"
1702 for conf in $initdir/etc/cmdline.d/*.conf ; do
496e3d96 1703 [ -e "$conf" ] || continue
fe273e39 1704 dinfo "$(< $conf)"
496e3d96 1705 _stored_cmdline=1
fe273e39 1706 done
496e3d96
HH
1707 fi
1708 if ! [[ $_stored_cmdline ]]; then
62c00a88 1709 dinfo "No dracut internal kernel commandline stored in the initramfs"
fe273e39
HR
1710 fi
1711fi
62c00a88 1712
636d2d46
HH
1713dinfo "*** Creating image file '$outfile' ***"
1714
1715if [[ $uefi = yes ]]; then
62c00a88
HH
1716 readonly uefi_outdir="$DRACUT_TMPDIR/uefi"
1717 mkdir "$uefi_outdir"
636d2d46 1718fi
c8a9a6b4 1719
80626ded
HH
1720if [[ $DRACUT_REPRODUCIBLE ]]; then
1721 find "$initdir" -newer "$dracutbasedir/dracut-functions.sh" -print0 \
1722 | xargs -r -0 touch -h -m -c -r "$dracutbasedir/dracut-functions.sh"
1723
10f8df1b
HH
1724 if [[ "$(cpio --help)" == *--reproducible* ]]; then
1725 CPIO_REPRODUCIBLE=1
1726 else
1727 dinfo "cpio does not support '--reproducible'. Resulting image will not be reproducible."
1728 fi
80626ded
HH
1729fi
1730
647b521f 1731[[ "$EUID" != 0 ]] && cpio_owner_root="-R 0:0"
c8a9a6b4 1732
b5b608e4 1733if [[ $create_early_cpio = yes ]]; then
b9909e33 1734 echo 1 > "$early_cpio_dir/d/early_cpio"
80626ded
HH
1735
1736 if [[ $DRACUT_REPRODUCIBLE ]]; then
1737 find "$early_cpio_dir/d" -newer "$dracutbasedir/dracut-functions.sh" -print0 \
1738 | xargs -r -0 touch -h -m -c -r "$dracutbasedir/dracut-functions.sh"
1739 fi
1740
5f2c30d9 1741 # The microcode blob is _before_ the initramfs blob, not after
62c00a88 1742 if ! (
0db98910 1743 umask 077; cd "$early_cpio_dir/d"
62c00a88
HH
1744 find . -print0 | sort -z \
1745 | cpio ${CPIO_REPRODUCIBLE:+--reproducible} --null $cpio_owner_root -H newc -o --quiet > "${DRACUT_TMPDIR}/initramfs.img"
1746 ); then
1747 dfatal "dracut: creation of $outfile failed"
1748 exit 1
1749 fi
5f2c30d9 1750fi
80626ded
HH
1751
1752if ! (
1753 umask 077; cd "$initdir"
1754 find . -print0 | sort -z \
1755 | cpio ${CPIO_REPRODUCIBLE:+--reproducible} --null $cpio_owner_root -H newc -o --quiet \
62c00a88 1756 | $compress >> "${DRACUT_TMPDIR}/initramfs.img"
80626ded 1757 ); then
dc4c1ee3 1758 dfatal "dracut: creation of $outfile failed"
734a0d9e 1759 exit 1
3b403b32 1760fi
2cc5e92e 1761
bd93e928 1762if (( maxloglvl >= 5 )) && (( verbosity_mod_l >= 0 )); then
dadd2b69 1763 if [[ $allowlocal ]]; then
62c00a88 1764 "$dracutbasedir/lsinitrd.sh" "${DRACUT_TMPDIR}/initramfs.img"| ddebug
dadd2b69 1765 else
62c00a88 1766 lsinitrd "${DRACUT_TMPDIR}/initramfs.img"| ddebug
dadd2b69 1767 fi
bbaa0d59 1768fi
1faecdc1 1769
60928f36
HH
1770umask 077
1771
636d2d46
HH
1772if [[ $uefi = yes ]]; then
1773 if [[ $kernel_cmdline ]]; then
1774 echo -n "$kernel_cmdline" > "$uefi_outdir/cmdline.txt"
1775 elif [[ $hostonly_cmdline = yes ]] && [ -d $initdir/etc/cmdline.d ];then
1776 for conf in $initdir/etc/cmdline.d/*.conf ; do
1777 [ -e "$conf" ] || continue
1778 printf "%s " "$(< $conf)" >> "$uefi_outdir/cmdline.txt"
1779 done
1780 else
1781 do_print_cmdline > "$uefi_outdir/cmdline.txt"
1782 fi
1783 echo -ne "\x00" >> "$uefi_outdir/cmdline.txt"
1784
1785 dinfo "Using UEFI kernel cmdline:"
1786 dinfo $(< "$uefi_outdir/cmdline.txt")
1787
3ac9cdb1 1788 [[ -s /usr/lib/os-release ]] && uefi_osrelease="/usr/lib/os-release"
636d2d46
HH
1789 [[ -s /etc/os-release ]] && uefi_osrelease="/etc/os-release"
1790
62c00a88
HH
1791 if objcopy \
1792 ${uefi_osrelease:+--add-section .osrel=$uefi_osrelease --change-section-vma .osrel=0x20000} \
1793 --add-section .cmdline="${uefi_outdir}/cmdline.txt" --change-section-vma .cmdline=0x30000 \
1794 --add-section .linux="$kernel_image" --change-section-vma .linux=0x40000 \
1795 --add-section .initrd="${DRACUT_TMPDIR}/initramfs.img" --change-section-vma .initrd=0x3000000 \
1796 "$uefi_stub" "${uefi_outdir}/linux.efi" \
60928f36 1797 && cp --reflink=auto "${uefi_outdir}/linux.efi" "$outfile"; then
62c00a88
HH
1798 dinfo "*** Creating UEFI image file '$outfile' done ***"
1799 else
1800 rm -f -- "$outfile"
1801 dfatal "*** Creating UEFI image file '$outfile' failed ***"
1802 exit 1
1803 fi
1804else
60928f36 1805 if cp --reflink=auto "${DRACUT_TMPDIR}/initramfs.img" "$outfile"; then
62c00a88
HH
1806 dinfo "*** Creating initramfs image file '$outfile' done ***"
1807 else
1808 rm -f -- "$outfile"
1809 dfatal "dracut: creation of $outfile failed"
1810 exit 1
1811 fi
636d2d46
HH
1812fi
1813
60928f36 1814command -v restorecon &>/dev/null && restorecon -- "$outfile"
62c00a88 1815
e316ae0e
AK
1816sync $outfile 2> /dev/null
1817if [ $? -ne 0 ] ; then
1818 dinfo "dracut: sync operartion on newly created initramfs $outfile failed"
1819 exit 1
1820fi
1821
3da58569 1822exit 0